#sccs	"@(#)adminbin:Namesys.sh	1.8"
#                                                                Namesys.sh
# PURPOSE: change uname of system
# CALLED BY: Admin-kit
# REQUIRED FILES: Namesys.form
# -------------------------------------------------------------------------

ERROR1="An error has been encountered in the form file Namesys.form\n  Please notify AT&T User Support.  Thank you."
ERROR2="The command provided was not recognized.\nPlease use Enter, Cancel, or a defined function key."
ERROR3="System name may contain between one and eight characters consisting of letters, numbers and underscore."
TERMCAP=
export TERMCAP
umask 022
USEWIN="-u"
USEWIN2="-iu"

UNAME=`uname -n`

PASS=`grep "^uucp::" /etc/passwd`
if [ -n "$PASS" ]
then
	oldpasswd=NO
else
	oldpasswd=YES
fi
export UNAME oldpasswd

while true
do
RET=`shform $USEWIN $UA/Namesys.form`
if [ "$?" != "0" ]
then
	message $ERROR1
	exit
fi

eval set $RET
newname=$2
passwd=$3

case $1 in
	Enter)
	 
if [ -z "$newname" ]
then
	message $ERROR3
	continue
fi
		case "$newname" in
		"!" )
			message $ERROR3
			continue
			;;
		"+" )
			message $ERROR3
			continue
			;;
		"-" )
			message $ERROR3
			continue
			;;
		"=" )
			message $ERROR3
			continue
			;;
		"&" )
			message $ERROR3
			continue
			;;
		"%" )
			message $ERROR3
			continue
			;;
		"*" )
			message $ERROR3
			continue
			;;
		"(" )
			message $ERROR3
			continue
			;;
		")" )
			message $ERROR3
			continue
			;;
		"|" )
			message $ERROR3
			continue
			;;
		"<" )
			message $ERROR3
			continue
			;;
		">" )
			message $ERROR3
			continue
			;;
		":" )
			message $ERROR3
			continue
			;;
		"," )
			message $ERROR3
			continue
			;;
		*,* )
			message $ERROR3
			continue
			;;
		esac

	word=`echo $newname | wc -w`
	if [ \( -n "$newname" \) -a \( $word = 0 \) ]
	then
		message -i "No change to the Electronic Mail name due to invalid entry!\n\nPlease hit Enter to continue"
		exit
	fi

	if [ \( -z "$newname" \) -a \( "$UNAME" != "UNIXPC" \) ]
	then 
		message -i "No change to the Electronic Mail name was made.\n\nPlease hit Enter to continue"
		exit
	fi
	
	if [ \( "$oldpasswd" = "$passwd" \) -a \( "$UNAME" = "$newname" \) ]
	then 
		message -i "No change to the Electronic Mail name was made.\n\nPlease hit Enter to continue"
		exit
	fi
	
	if [ \( -z "$newname" \) -o \( "$newname" = "UNIXPC" \) ]
	then 
		message "The Electronic Mail name \"UNIXPC\" is supplied on all delivered systems.  It must be changed in order to allow data communications with other computers."

	else

		LENGTH=`expr "$newname" : '.*'`
		MATCH=`expr "$newname" : '[a-z,A-Z,0-9,_]\{1,8\}'`
		if [ "$LENGTH" != "$MATCH" ]
		then	
			message $ERROR3
		else
			break
		fi

	fi
	;;

# This is the Exit code if command is cancelled
	Cancel)
	exit
	;;

# This is the Help code
	Help)
	/usr/bin/uahelp -h $UA/admin.hlp -t "System Name"
	;;

# Unrecognizable return from action key
	*)
	message $ERROR2
	;;

esac

clear
done

if [ -x /usr/net/netname ]
then
	/usr/net/netname -r $newname
	if [ "$?" != 0 ]
	then
		exit
	else
		echo "/usr/net/netname -n $newname" >/etc/namesys 
	fi
else
	setuname -n $newname
	echo "setuname -n $newname" >/etc/namesys 
fi



clear
message ${USEWIN2} "The Electronic Mail name of the system is now "$newname". \
If there are systems which have communicated  \
electronically with this system in the past, \
you should notify their system administrators \
that a change has been made to your system.\n\nPlease hit Enter to continue"


if [ \( "$passwd" = "YES" \) -o \( "$passwd" = "yes" \) -o \( "$passwd" = "Yes" \) -o \( "$passwd" = "y" \) -o \( "$passwd" = "Y" \) ]
then
	if [ "$oldpasswd" = NO ]
	then
		/usr/bin/password uucp 1
		/usr/bin/uucppwd
	fi
else
	if [ "$oldpasswd" = YES ]
	then
		/usr/bin/password uucp 0
		/usr/bin/uucppwd
	fi
fi


# -------------------------------------------------------------------------
#  EXECUTABLE PROGRAM ENDS HERE                                  Namesys.sh
