#sccs	"@(#)adminbin:RS232.sh	1.6"
#                                                               RS232.sh
# PURPOSE: Configure the software to a particular device type on RS232
# CALLED BY: RS232
# REQUIRED FILES: RS232.form
# -------------------------------------------------------------------------

ERROR1="An error has been encountered in an RS232 form file.\n  Please notify AT&T User Support.  Thank you."
ERROR2="The command provided was not recognized.\nPlease use Enter, Cancel, or a defined function key."
MESS1="The RS232 port is now set up.  \n\nPlease press Enter to continue."

TERMCAP=
export TERMCAP
umask 022

# OLDTYPE is used to store the value of the type so that it can be 
# compared to the TYPE newly selected.
 
OLDTYPE='NONE'
SPEED=9600
INCOME='HOST only'
TYPE='NONE'
# get the data from /etc/.rs232
if [ -s /etc/.rs232 ]
then
	. /etc/.rs232
	if [ "$TYPE" = 'PRINTER' ]
	then
		RSfree.sh 000
		if [ "$?" != "0" ]
		then
			exit
		fi
		INCOME='HOST only'
		SPEED=9600
		NAME=
	fi
fi

# store the value of TYPE before the user makes any new selection
OLDTYPE="$TYPE"

# check Hardware Flow Control configuration
HFCINIT=/etc/daemons/tty000.init 
if [ -x $HFCINIT ]
then 
	HFC=Yes
else 
	HFC=No
fi

export TYPE NAME SPEED INCOME OLDTYPE HFC

while true
do

RET=`shform -u $UA/RS232a.form`
if [ "$?" != "0" ]
then
	message $ERROR1
	exit
fi

BAD=
eval set $RET

case $1 in
# Executable code for the "enter" option follows here
	Enter)
	shift
	RSfree.sh 000 noconfirm
	if [ "$?" != "0" ] ; then exit ; fi

	TYPE=$1
	SPEED=$2
	HFC=$3

	case $TYPE in
		NONE)
			clear
			message -iu $MESS1
			exit
			;;
		COMPUTER)	
			while true
			do
		
			clear
			RET=`shform -u $UA/RS232e.form`
			if [ "$?" != "0" ]
			then
				message $ERROR1
				exit
			fi
			eval set $RET
			if [ "$1" = "Help" ]
			then
				/usr/bin/uahelp -h /usr/lib/ua/admin.hlp -t "RS232 Setup"
			elif [ "$1" != "Enter" ]
                        then
                                exit
                        elif [ true ] 
			then
	        		RET2=$2
	        		set $2
	            		if [ "$1" != "HOST" ]
	            		then
		           		echo "DIR tty000 0 $SPEED" >> /usr/lib/uucp/L-devices
	            		fi
		        	if [ "$1" != "CALLER" ]
	             		then
		           		grep -v  "000:.*getty" /etc/inittab > /tmp/init$$
			         	mv /tmp/init$$ /etc/inittab
			            	echo " 000:2:respawn:/etc/getty tty000 $SPEED" >> /etc/inittab
	            			telinit q
		             	fi
	             		INCOME=$RET2
				break
                        fi
			clear
			done
			;;
		MODEM)
			while true
			do

			clear
			if [ -n "`find /usr/lib/uucp/modemcap -newer $UA/RS232d.form -print`" ]
			then
				grep -v Name= $UA/RS232d.form >/tmp/RS232d.form$$
				mv /tmp/RS232d.form$$ $UA/RS232d.form	
				echo "Name=Answer_only" >> $UA/RS232d.form
				grep '^#' /usr/lib/uucp/modemcap|grep Name=|cut -dN -f2-|sort|sed 's/ame/Name/' >> $UA/RS232d.form
			fi
			RET=`shform -u $UA/RS232d.form`
			if [ "$?" != "0" ]
			then
				message $ERROR1
				exit
			fi
			eval set $RET
			if [ "$1" = "Help" ]
			then
				/usr/bin/uahelp -h /usr/lib/ua/admin.hlp -t "RS232 Setup"
                        elif [ "$1" != "Enter" ]
                        then
                                exit
                        elif [ true ]
			then
			        if [ "$2" != "Answer_only" ]
			        then
			        	echo "ACU tty000 $2 $SPEED" >> /usr/lib/uucp/L-devices
			                INCOME="BOTH HOST and CALLER"
			        else
		                        INCOME="HOST only"
			        fi
		        	NAME=$2
		          	grep -v  "000:.*getty" /etc/inittab > /tmp/init$$
	            		mv /tmp/init$$ /etc/inittab
		           	echo " 000:2:respawn:/etc/getty tty000 $SPEED" >> /etc/inittab
		           	telinit q
				break
                        fi
			clear
			done
			;;
		TERMINAL)
	            	NAME=
		        INCOME="HOST only"
	            	grep -v  "000:.*getty" /etc/inittab > /tmp/init$$
	            	mv /tmp/init$$ /etc/inittab
		        echo " 000:2:respawn:/etc/getty tty000 $SPEED" >> /etc/inittab
	            	telinit q
			clear
			;;
		OTHER)
			while true
			do
			clear
			RET=`shform -u $UA/RS232b.form`
			if [ "$?" != "0" ]
			then
				message $ERROR1
				exit
			fi
                        RET2=$2
			eval set $RET
 			if [ "$1" = "Help" ]
			then
				/usr/bin/uahelp -h /usr/lib/ua/admin.hlp -t "RS232 Setup"
                        elif [ "$1" != "Enter" ]
                        then
        			exit
			elif [ true ]
			then
  				RET2=$TMP
	            		NAME=$2
	             		RET3=$3
	             		set $3
	             		if [ "$1" != "HOST" ]
			        then
	             			echo "DIR tty000 0 $SPEED" >> /usr/lib/uucp/L-devices
	           		fi
	            		if [ "$1" != "CALLER" ]
	            		then
	             			grep -v  "000:.*getty" /etc/inittab > /tmp/init$$
	             			mv /tmp/init$$ /etc/inittab
		            		echo " 000:2:respawn:/etc/getty tty000 $SPEED" >> /etc/inittab
	             			telinit q
	             		fi
	              		INCOME=$RET3
				break
                        fi
			clear
			done
			;;
	esac
	cat >/etc/.rs232 <<END
TYPE='$TYPE'
NAME='$NAME'
SPEED='$SPEED'
INCOME='$INCOME'
END

# do HFC configuration
	if [ "$HFC" = "Yes" ]
	then
		mkdir /etc/daemons >/dev/null 2>&1
		echo "/etc/hfc_ctl +/dev/tty000" >$HFCINIT
		chmod +x $HFCINIT
		. $HFCINIT
	fi

	clear
	message -iu $MESS1
	break
	;;

# This is the help screen
	Help)
		/usr/bin/uahelp -h /usr/lib/ua/admin.hlp -t "RS232 Setup"
	;;

# This is the Exit code if command is cancelled
	Cancel)
	exit
	;;

# Unrecognizable return from action key
	*)
	message $ERROR2
	;;

# End of main case based on the action key
esac
clear
done

# -------------------------------------------------------------------------
#  EXECUTABLE PROGRAM ENDS HERE                                 RSdevice.sh
# =========================================================================
