/**********************************************************\
* Rocks : a bit-mapped arcade game for the AT&T UNIX PC.   *
*                                                          *
* By : Hans Jespersen                                      *
*                                                          *
\**********************************************************/

#include "rocks.h"
#include <sys/font.h>

void wininit()
{
	int wid, i;
	struct umdata mouse;
	struct icon myicon;

	close( 0 );
	close( 1 );
	close( 2 );
	wid = open( "/dev/window",O_RDWR );
	dup( 0 );
	dup( 0 );
        winit();
        if( !iswind() ) {
                fprintf(stderr,"\nSorry, you must use bit-mapped display!\n");
                wexit(-1);
        }
        wn = wcreate( 0, 0, 25, 80, NBORDER );
	wuser( wn, "Rocks" );
	wprintf( wn, "\033[=1C" );
	noecho();
	stars();
        clear();
	nodelay( 0,1 );
	wprompt( wn, "score :      0" );
	ioctl( wid, WIOCGETMOUSE, &mouse );
	mouse.um_flags = MSDOWN;
	myicon.ic_fc.fc_hs = 0;
	myicon.ic_fc.fc_vs = 0;
	myicon.ic_fc.fc_ha = 0;
	myicon.ic_fc.fc_va = 0;
	myicon.ic_fc.fc_hi = 0;
	myicon.ic_fc.fc_vi = 0;
	for( i=0; i < 64; i+=2 )
		myicon.ic_raster[i] = 0x0000; 
	mouse.um_icon = &myicon;
	ioctl( wid, WIOCSETMOUSE, &mouse );
	keypad( 0, 1 );
}
 
void cleanup()
{
        clear();
	wprintf( wn, "\033[=0C" );
        wdelete( wn );		/* Quick, the boss is comming */
        exit( 0 );
}
